<?php

namespace Pinpoint\DeliveryDate\Model\Config\Shipping\Source;

use Magento\Framework\Data\OptionSourceInterface;
use Magento\Framework\Option\ArrayInterface;

/**
 * Class DateFormats
 * @package Pinpoint\DeliveryDate\Model\Config\Shipping\Source
 */
class DateFormats implements OptionSourceInterface, ArrayInterface
{
    /**
     * @var array $options
     */
    protected $options = [];

    /**
     * Get Options
     *
     * @return array
     */
    public function toOptionArray()
    {
        if (!$this->options) {
            $this->options = [
                [
                    'value' => 'd/m/Y'
                ],
                [
                    'value' => 'Y/m/d'
                ],
                [
                    'value' => 'd-m-Y'
                ],
                [
                    'value' => 'Y-m-d'
                ],
                [
                    'value' => 'l jS \of F Y'
                ],
                [
                    'value' => 'l jS \of F'
                ],
                [
                    'value' => 'F d, Y'
                ],
                [
                    'value' => 'M j, Y'
                ],
                [
                    'value' => 'l, F jS, Y'
                ]
            ];
        }

        foreach ($this->options as &$option) {
            $option['label'] = sprintf('%s - %s', $option['value'], date($option['value'], time()));
        }

        return $this->options;
    }
}